/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the Metric type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Metric{}

// Metric struct for Metric
type Metric struct {
	Name string `json:"name"`
	Type MetricType `json:"type"`
	CustomType *string `json:"custom_type,omitempty"`
	Trigger Trigger `json:"trigger"`
	RelatedActions []string `json:"related_actions,omitempty"`
	Contexts []MetricContext `json:"contexts,omitempty"`
}

// NewMetric instantiates a new Metric object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMetric(name string, type_ MetricType, trigger Trigger) *Metric {
	this := Metric{}
	this.Name = name
	this.Type = type_
	this.Trigger = trigger
	return &this
}

// NewMetricWithDefaults instantiates a new Metric object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMetricWithDefaults() *Metric {
	this := Metric{}
	return &this
}

// GetName returns the Name field value
func (o *Metric) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *Metric) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *Metric) SetName(v string) {
	o.Name = v
}

// GetType returns the Type field value
func (o *Metric) GetType() MetricType {
	if o == nil {
		var ret MetricType
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *Metric) GetTypeOk() (*MetricType, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *Metric) SetType(v MetricType) {
	o.Type = v
}

// GetCustomType returns the CustomType field value if set, zero value otherwise.
func (o *Metric) GetCustomType() string {
	if o == nil || IsNil(o.CustomType) {
		var ret string
		return ret
	}
	return *o.CustomType
}

// GetCustomTypeOk returns a tuple with the CustomType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Metric) GetCustomTypeOk() (*string, bool) {
	if o == nil || IsNil(o.CustomType) {
		return nil, false
	}
	return o.CustomType, true
}

// HasCustomType returns a boolean if a field has been set.
func (o *Metric) HasCustomType() bool {
	if o != nil && !IsNil(o.CustomType) {
		return true
	}

	return false
}

// SetCustomType gets a reference to the given string and assigns it to the CustomType field.
func (o *Metric) SetCustomType(v string) {
	o.CustomType = &v
}

// GetTrigger returns the Trigger field value
func (o *Metric) GetTrigger() Trigger {
	if o == nil {
		var ret Trigger
		return ret
	}

	return o.Trigger
}

// GetTriggerOk returns a tuple with the Trigger field value
// and a boolean to check if the value has been set.
func (o *Metric) GetTriggerOk() (*Trigger, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Trigger, true
}

// SetTrigger sets field value
func (o *Metric) SetTrigger(v Trigger) {
	o.Trigger = v
}

// GetRelatedActions returns the RelatedActions field value if set, zero value otherwise.
func (o *Metric) GetRelatedActions() []string {
	if o == nil || IsNil(o.RelatedActions) {
		var ret []string
		return ret
	}
	return o.RelatedActions
}

// GetRelatedActionsOk returns a tuple with the RelatedActions field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Metric) GetRelatedActionsOk() ([]string, bool) {
	if o == nil || IsNil(o.RelatedActions) {
		return nil, false
	}
	return o.RelatedActions, true
}

// HasRelatedActions returns a boolean if a field has been set.
func (o *Metric) HasRelatedActions() bool {
	if o != nil && !IsNil(o.RelatedActions) {
		return true
	}

	return false
}

// SetRelatedActions gets a reference to the given []string and assigns it to the RelatedActions field.
func (o *Metric) SetRelatedActions(v []string) {
	o.RelatedActions = v
}

// GetContexts returns the Contexts field value if set, zero value otherwise.
func (o *Metric) GetContexts() []MetricContext {
	if o == nil || IsNil(o.Contexts) {
		var ret []MetricContext
		return ret
	}
	return o.Contexts
}

// GetContextsOk returns a tuple with the Contexts field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Metric) GetContextsOk() ([]MetricContext, bool) {
	if o == nil || IsNil(o.Contexts) {
		return nil, false
	}
	return o.Contexts, true
}

// HasContexts returns a boolean if a field has been set.
func (o *Metric) HasContexts() bool {
	if o != nil && !IsNil(o.Contexts) {
		return true
	}

	return false
}

// SetContexts gets a reference to the given []MetricContext and assigns it to the Contexts field.
func (o *Metric) SetContexts(v []MetricContext) {
	o.Contexts = v
}

func (o Metric) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Metric) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["name"] = o.Name
	toSerialize["type"] = o.Type
	if !IsNil(o.CustomType) {
		toSerialize["custom_type"] = o.CustomType
	}
	toSerialize["trigger"] = o.Trigger
	if !IsNil(o.RelatedActions) {
		toSerialize["related_actions"] = o.RelatedActions
	}
	if !IsNil(o.Contexts) {
		toSerialize["contexts"] = o.Contexts
	}
	return toSerialize, nil
}

type NullableMetric struct {
	value *Metric
	isSet bool
}

func (v NullableMetric) Get() *Metric {
	return v.value
}

func (v *NullableMetric) Set(val *Metric) {
	v.value = val
	v.isSet = true
}

func (v NullableMetric) IsSet() bool {
	return v.isSet
}

func (v *NullableMetric) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMetric(val *Metric) *NullableMetric {
	return &NullableMetric{value: val, isSet: true}
}

func (v NullableMetric) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMetric) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


